#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

#define TCOUNT 10
#define COUNT_LIMIT 6

int     count = 0;
pthread_mutex_t count_mutex = PTHREAD_MUTEX_INITIALIZER;

void *inc_count() 
{
  int j,i;
  double result=0.0;
  int thread_id = pthread_self();

  for (i=0; i < TCOUNT; i++) {
    
    pthread_mutex_lock(&count_mutex);

    count++;
    printf("Producer locked mutex and incrementing count %d\n", count);

    if (count == COUNT_LIMIT) {
      printf("inc_count(): producer reached the threshold count = %d.\n", count);
    }
    
     printf("Producer unlocking the mutex\n");
     pthread_mutex_unlock(&count_mutex);
    
    /* Do some work so threads can alternate on mutex lock */
    for (j=0; j < 10000; j++)
     result = result + (double)random();
   }
   pthread_exit(NULL);
}

void *watch_count() 
{
  int thread_id = pthread_self();

  printf("Starting consumer thread.\n");

  /*
  Lock mutex and wait for signal.  Note that the pthread_cond_wait routine
  will automatically and atomically unlock mutex while it waits. 
  Also, note that if COUNT_LIMIT is reached before this routine is run by
  the waiting thread, the loop will be skipped to prevent pthread_cond_wait
  from never returning.
  */
  pthread_mutex_lock(&count_mutex);
  printf("Consumer locked the mutex\n");
  
  if ( COUNT_LIMIT > 3) {
    count += 1000;
    printf("Consumer incremented count by thousand:  %d\n", count);
  }
 
   printf("Consumer unclocking the mutex\n");
   pthread_mutex_unlock(&count_mutex);
  
   pthread_exit(NULL);
}

int main(int argc, char *argv[])
{
  int i, rc;
  pthread_t producer, consumer;
  
  pthread_create(&producer, NULL, inc_count, NULL);
  pthread_create(&consumer, NULL, watch_count, NULL);

  pthread_join(producer1, NULL);
  pthread_join(consumer, NULL);

  /* Clean up and exit */
  pthread_mutex_destroy(&count_mutex);
  
  exit(0);
}

